package net.sf.alchim.codeplus.spoonprocessor;

import net.sf.alchim.codeplus.annotation.CheckBefore;

import spoon.processing.AbstractProcessor;
import spoon.reflect.code.CtBlock;
import spoon.reflect.code.CtExpression;
import spoon.reflect.declaration.CtClass;
import spoon.reflect.declaration.CtMethod;
import spoon.template.Substitution;

public class CheckBeforeProcessor extends AbstractProcessor<CtMethod<?>> {

    public void process(CtMethod<?> m) {
        CheckBefore annotation = m.getAnnotation(CheckBefore.class);
        if (annotation == null) {
            return;
        }
        for(String check : annotation.value()) {
            CtExpression<Boolean> checkExpr = getFactory().Code().createCodeSnippetExpression(check);
            CtBlock<?> checkBlock = Substitution.substituteMethodBody(
                    (CtClass<?>) m.getDeclaringType(),
                    new CheckBeforeTemplate(check, checkExpr),
                    "check"
            );
            m.getBody().insertBegin(checkBlock);
        }
        AnnotationHelper.removeAnnotation(m, CheckBefore.class);
    }

}
