package net.sf.alchim.codeplus.spoonprocessor;

import java.util.ArrayList;
import java.util.List;

import spoon.processing.AbstractProcessor;
import spoon.reflect.declaration.CtClass;
import spoon.reflect.declaration.CtField;
import spoon.reflect.declaration.ModifierKind;
import spoon.reflect.reference.CtFieldReference;
import spoon.template.Substitution;

/**
 * This processor inserts the getters and the setters typical implementations
 * for all the fields annotated with the
 * {@link spoon.examples.fieldaccess.annotation.Access} annotation.
 */
public class StupidGetSetGenerator<_FieldType_> extends AbstractProcessor<CtField<_FieldType_>> {

    public static List<CtFieldReference<?>> fields = new ArrayList<CtFieldReference<?>>();

    /**
     * TODO: check if getter and setter not exist
     */
    public void process(CtField<_FieldType_> field) {
        if (field.getModifiers().contains(ModifierKind.STATIC)) {
            return;
        }
        if (field.getModifiers().contains(ModifierKind.FINAL)) {
            return;
        }
        if (!field.getModifiers().contains(ModifierKind.PUBLIC)) {
            return;
        }
        fields.add(field.getReference());
        Substitution.insertAll(field.getParent(CtClass.class), new StupidGetSetTemplate<_FieldType_>(field.getType(), field.getSimpleName()));
    }

}
